#!/usr/bin/perl -w

use strict;

my %addresses = ();

my $allocs = 0;
my $frees = 0;

my $totalHeapSize = 0;

my $maxHeapSize = 0;

my @line = ();
my @fields = ();

while (<>)
{
	@line = split / /;

	if ($line[0] eq 'A')
	{
		$addresses{"$line[1] $line[2]"} = $_;
		++$allocs;

		$totalHeapSize += $line[4];

		if ($maxHeapSize < $totalHeapSize)
		{
			$maxHeapSize = $totalHeapSize;
		}

	} elsif ($line[0] eq 'F')
	{
		@fields = split / /, $addresses{"$line[1] $line[2]"};

		$totalHeapSize -= $fields[4];

		delete $addresses{"$line[1] $line[2]"};
		++$frees;
	}
}

print "$allocs Allocations; $frees Frees\n";
print "Total heap size = $totalHeapSize bytes\n";
print "Maximum heap size = $maxHeapSize bytes\n\n";

foreach my $key (keys %addresses)
{
	print "$addresses{$key}\n";
}
