/*
 * Copyright (c) 2003-2005 by John Schmerge
 * All rights reserved.
 *
 * util.h
 *
 * $Id: util.h,v 1.5 2005/04/12 12:34:29 john Exp $
 */

#ifndef UTIL_H
#define UTIL_H 1

typedef void (*MallocHandler) (void);

/* ********************************************************************
 */
void defaultMallocHandler(void);

/* ********************************************************************
 */
MallocHandler setMallocHandler(MallocHandler h);

/* ********************************************************************
 */
#if (MEM_DEBUG)
#	define safeMalloc(x) _safeMalloc(x, __LINE__, __FILE__)
	void * _safeMalloc(size_t sz, int line, char * file);
#else
#	define safeMalloc(x) _safeMalloc(x)
	void * _safeMalloc(size_t sz);
#endif

/* ********************************************************************
 */
char * safeStrdup(const char * s);

/* ********************************************************************
 */
void safeFree(void * ptr);

/* ********************************************************************
 */
unsigned char * readLine(FILE * f);

/* *******************************************************************
 */
void freeReadlineBuffer(void);

#endif /* UTIL_H */

/* ********************************************************************
 * $Log: util.h,v $
 * Revision 1.5  2005/04/12 12:34:29  john
 * Merge from DEVEL branch
 *
 * Revision 1.4  2005/04/12 03:13:49  john
 * Pulled new libutil work into project
 *
 * Revision 1.1.1.1.2.2  2005/04/12 02:22:54  john
 * Merge from head
 *
 * Revision 1.3  2005/03/27 01:21:09  john
 * updated copyright
 *
 * Revision 1.2  2005/03/26 01:42:34  john
 * Merge from branch micron_autoconf
 *
 * Revision 1.1.1.1.4.1  2005/03/25 02:22:04  john
 * Modified cpp conditionals to play nice with autoconf
 *
 * Revision 1.1.1.1.2.1  2005/03/17 12:22:46  john
 * added memory overwrite protection
 *
 * Revision 1.1.1.1  2005/02/26 12:57:27  john
 * initial import of sources
 *
 */
